#include <stdio.h>
#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <set>


#define MP(f, s) make_pair(f, s)
#define CHECK_INPUT_DATA

const int MaxB = 100*1000;
const int MaxP = 200;
const int MaxD = 200;

using namespace std;


int p, d;
int graduatedNumber, sentDownNumber;
vector< vector< pair<int, int> > > plan;
vector<int> bookTakenBy, isStudentSentDown, studentsPlanCounter, dependOn;
vector< set<int> > readBooks;

#ifdef CHECK_INPUT_DATA
set<int> takenBooksByStudent;
char msgBuffer[1024];
set<int>::iterator siit;

void myThrow(char* msg) {
  cerr << msg;
  throw ":-(";
}

void checkRange(int l, int value, int r, char* subj) {
  if (!(l <= value && value <= r)) {
    sprintf(msgBuffer, "BAD %s: value %d out of range [%d; %d]", subj, value, l, r);
    myThrow(msgBuffer);
  }
}
#endif


int main() {
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin >> p >> d;
#ifdef CHECK_INPUT_DATA
  checkRange(1, p, MaxP, "students number");
  checkRange(1, d, MaxD, "days number");
#endif
  plan.resize(p);
  isStudentSentDown.resize(p);
  studentsPlanCounter.resize(p);
  readBooks.resize(p);
  dependOn.resize(p);
  bookTakenBy.resize(MaxB+1);
  for (int i = 0; i < p; i++) {
    plan[i].resize(d);
#ifdef CHECK_INPUT_DATA
    takenBooksByStudent.clear();
#endif
    for (int j = 0; j < d; j++) {
      int r, t; cin >> r >> t;
#ifdef CHECK_INPUT_DATA
      if (r) {
        checkRange(1, r, MaxB, "book number");
        siit = takenBooksByStudent.find(r);
        if (siit == takenBooksByStudent.end()) {
          sprintf(msgBuffer, "BAD plan: student #%d can't return book #%d on day #%d because he don't have it!", i+1, r, j+1);
          myThrow(msgBuffer);
        }
        takenBooksByStudent.erase(siit);
      }
      if (t) {
        checkRange(0, t, MaxB, "book number");
        siit = takenBooksByStudent.find(t);
        if (siit != takenBooksByStudent.end()) {
          sprintf(msgBuffer, "BAD plan: student #%d can't take book #%d on day #%d because he has already taken it!", i+1, t, j+1);
          myThrow(msgBuffer);
        }
        takenBooksByStudent.insert(t);
      }
#endif
      plan[i][j] = MP(r, t);
    }
#ifdef CHECK_INPUT_DATA
    if (takenBooksByStudent.size()) {
      sprintf(msgBuffer, "BAD plan: student #%d has some books after all days!", i+1);
      myThrow(msgBuffer);
    }
#endif
  }

  fill(bookTakenBy.begin(), bookTakenBy.end(), -1);
  fill(dependOn.begin(), dependOn.end(), -1);
  while (graduatedNumber + sentDownNumber < p) {
    for (int st = 0; st < p; st++) {
      int& currStudCounter = studentsPlanCounter[st];
      if (isStudentSentDown[st] || currStudCounter  == d) {
        continue;
      }
      int returnBookNumber = plan[st][currStudCounter].first;
      int takenBookNumber = plan[st][currStudCounter].second;
      int& donst = dependOn[st];
      if (bookTakenBy[takenBookNumber] == -1 || takenBookNumber == returnBookNumber) {
        bookTakenBy[returnBookNumber] = -1;
        if (takenBookNumber) {
          bookTakenBy[takenBookNumber] = st;
          readBooks[st].insert(takenBookNumber);
          donst = -1;
        }
        graduatedNumber += ++currStudCounter == d;
      } else {
        if (donst == st || donst != -1 && isStudentSentDown[donst]) {
          sentDownNumber += isStudentSentDown[st] = true;
          continue;
        }
        donst = bookTakenBy[takenBookNumber];
        if (dependOn[donst] != -1) {
          donst = dependOn[donst];
        }
      }
    }
  }

  for (int st = 0; st < p; st++) {
    cout << readBooks[st].size() << " " << isStudentSentDown[st] << endl;
  }

  fclose(stdin);
  fclose(stdout);
  return 0;
}
